/*
 * XLife Copyright 1989 Jon Bennett jb7m+@andrew.cmu.edu, jcrb@cs.cmu.edu
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software without
 * specific, written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any purpose.  It
 * is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 */

#include "defs.h"

void gentab(void) {
    int i;

    for (i = 0; i < 0x88890; i++) {
       lookup[i] = 0;
       if ((i & 0x1) && (live & 1 << ((i & 0xf0) >> 4)))
             lookup[i] |= 1;
       if ((i & 0x2) && (live & 1 << ((i & 0xf00) >> 8)))
             lookup[i] |= 2;
       if ((i & 0x4) && (live & 1 << ((i & 0xf000) >> 12)))
             lookup[i] |= 4;
       if ((i & 0x8) && (live & 1 << ((i & 0xf0000) >> 16)))
             lookup[i] |= 8;
       if (((i & 0x1) == 0) && (born & 1 << ((i & 0xf0) >> 4)))
             lookup[i] |= 1;
       if (((i & 0x2) == 0) && (born & 1 << ((i & 0xf00) >> 8)))
             lookup[i] |= 2;
       if (((i & 0x4) == 0) && (born & 1 << ((i & 0xf000) >> 12)))
             lookup[i] |= 4;
       if (((i & 0x8) == 0) && (born & 1 << ((i & 0xf0000) >> 16)))
             lookup[i] |= 8;
    }
}

void gentab2(void) { /* generated, e.g., brian's brain */
    register int i, k, l;

    if (maxstates > 4)
      for (i = 0; i < 0x8900; i++) {
       lookup2[i] = 0;
       if ((i & 0xf) > 1)
           lookup2[i] = ((i & 0xf) + 1)%maxstates;
       else if (i & 0xf)
           if (live & 1 << ((i & 0xf00) >> 8))
             lookup2[i] |= 1;
           else
             lookup2[i] |= 2;
       else
           if (born & 1 << ((i & 0xf00) >> 8))
             lookup2[i] |= 1;
       k  = i >> 4;
       if ((k & 0xf) > 1)
           lookup2[i] |= ((k & 0xf) + 1)%maxstates << 8;
       else if (k & 0xf)
           if (live & 1 << (k >> 8))
             lookup2[i] |= 0x100;
           else
             lookup2[i] |= 0x200;
       else if (born & 1 << (k >> 8))
             lookup2[i] |= 0x100;
      }
    else
      for (i = 0; i < 0x888900; i++) {
         lookup4[i] = 0;
         for (l = 0; l < 4; l++) {
            k = i >> 2*l & 3;
            if (k > 1)
              lookup4[i] |= (k + 1)%maxstates << 8*l;
            else if (k)
              if (live & 1 << (i >> 4*l + 8 & 0xf))
                lookup4[i] |= 1 << 8*l;
              else
                lookup4[i] |= 2 << 8*l;
            else if (born & 1 << (i >> 4*l + 8 & 0xf))
              lookup4[i] |= 1 << 8*l;
         }
      }
}

void gentab3(void) { /* wireworld */
    register int i, k, l;

    for (i = 0; i < 0x888900; i++) {
       lookup4[i] = 0;
       for (l = 0; l < 4; l++) {
          k = i >> 2*l & 3;
          if (k == 3)
            if (born & 1 << (i >> 4*l + 8 & 0xf))
              lookup4[i] |= 1 << 8*l;
            else
              lookup4[i] |= 3 << 8*l;
          else if (k)
            lookup4[i] |= (k + 1)%maxstates << 8*l;
       }
    }
}
